#include	"Volumes.h"

// Physics object

void clPObject::funcPush( clVec2 vPush, clVec2 vNormal, float fImpulse )
{
	clVec2	vDel = vPos - vPush;

	this->vVel += vNormal * fImpulse;
	this->fW += ( vNormal ^ vDel ) * fImpulse;
}


// AABB

void clAABB::funcReload( void )
{
	this->vVec[ 0 ].VecSet( this->vPos.x - this->vSiz.x, this->vPos.y - this->vSiz.y );
	this->vVec[ 1 ].VecSet( this->vPos.x - this->vSiz.x, this->vPos.y + this->vSiz.y );
	this->vVec[ 2 ].VecSet( this->vPos.x + this->vSiz.x, this->vPos.y + this->vSiz.y );
	this->vVec[ 3 ].VecSet( this->vPos.x + this->vSiz.x, this->vPos.y - this->vSiz.y );
}

// Circle

void clSphere::funcReload( void )
{
	//   
}

void clSphere::funcRender( int iCount )
{
	float			fTemp = ( 6.48 / iCount );

	glBegin( GL_LINE_LOOP );
		for( int i = 0; i < iCount; i++ )
		{
			glVertex2f( vPos.x + cos( i * fTemp ) * fRadius,
				        vPos.y + sin( i * fTemp ) * fRadius );
		} 
	glEnd();
}

// Line

void clLine::funcReload( void )
{
	 this->vVec[ 0 ] = this->vPos - this->vDir * this->fHalf;
	 this->vVec[ 1 ] = this->vPos + this->vDir * this->fHalf;
}

void clLine::funcRender( void )
{
//	this->vDir.VecSet( cos( this->fAngle ), sin( this->fAngle ) );
	glBegin( GL_LINES );
		glVertex2fv( ( float * )&( this->vPos - ( this->vDir * this->fHalf ) ) );
		glVertex2fv( ( float * )&( this->vPos + ( this->vDir * this->fHalf ) ) );
	glEnd();
}

// OBB

void clOBB::funcReload( void )
{
	clVec2	r[ 4 ];

	r[ 0 ].VecSet( - vSiz.x, - vSiz.y );
	r[ 1 ].VecSet( - vSiz.x, + vSiz.y );
	r[ 2 ].VecSet( + vSiz.x, + vSiz.y );
	r[ 3 ].VecSet( + vSiz.x, - vSiz.y );

	r[ 0 ].VecRotate( this->fAngle );
	r[ 1 ].VecRotate( this->fAngle );
	r[ 2 ].VecRotate( this->fAngle );
	r[ 3 ].VecRotate( this->fAngle );

	this->vVec[ 0 ] = this->vPos + r[ 0 ];
	this->vVec[ 1 ] = this->vPos + r[ 1 ];
	this->vVec[ 2 ] = this->vPos + r[ 2 ];
	this->vVec[ 3 ] = this->vPos + r[ 3 ];
}

void clOBB::funcRender( void )
{
	glBegin( GL_LINE_LOOP );
		glVertex2fv( ( float * )&( this->vVec[ 0 ] ) );
		glVertex2fv( ( float * )&( this->vVec[ 1 ] ) );
		glVertex2fv( ( float * )&( this->vVec[ 2 ] ) );
		glVertex2fv( ( float * )&( this->vVec[ 3 ] ) );
	glEnd();
}
