/* ===============================================================================================
 *  :
 * ( * )     
 * ( * )        (   )
 * ( * )    
 * -----------------------------------------------------------------------------------------------
 * AABB x AABB
 * AABB x 
 *  x 
 *  x 
 *  x OBB
 * AABB x 
 * OBB x 
 *  x 
 * AABB x OBB
 * OBB x OBB
 * -----------------------------------------------------------------------------------------------
 *     
 *		17.10.2006 (C) faceH0r
 * ===============================================================================================
 */

#pragma comment( lib, "opengl32.lib" )
#pragma comment( lib, "glu32.lib" )
#pragma comment( lib, "glaux.lib" )

#include	<windows.h>

#include	<gl/gl.h>

#include	"Vector.h"
#include	"Volumes.h"
#include	"Intersect.h"

#include	<stdio.h>
#include	<math.h>

HDC			hDc;
HGLRC		hRc;

float		fCurTime;
float		fDelTime;
float		fOldTime;

bool		bKeys[ 256 ];

int			iState = 0;
float		fSpeed = 0.001f;

// ,    
clSphere	sph;
clOBB		obb;
clLine		line;

clOBB		player;		//  

clIntersect	cl;

void		funcGenerate	( void )
{
	// 
	sph.fAngle = 1.0f;
	sph.fRadius = ( ( rand() % 50 ) * 0.01f ) + 0.01f;
	sph.fW = 0.0f;
	sph.vPos.VecSet( ( rand() % 100 ) * 0.01f - 0.5f, ( rand() % 100 ) * 0.01f - 0.5f );
	sph.vVel.VecZero();
	// 
	line.fAngle = 0.0f;
	line.fHalf = ( rand() % 100 ) * 0.005f;
	line.fW = 0.0f;
	line.vPos.VecSet( ( rand() % 100 ) * 0.01f - 0.5f, ( rand() % 100 ) * 0.01f - 0.5f );
	line.vDir.VecSet( ( rand() % 100 ) * 0.01f - 0.5f, ( rand() % 100 ) * 0.01f - 0.5f );
	line.vDir.VecNormalize();
	line.vVel.VecZero();
	line.funcReload();
	// OBB
	obb.vPos.VecSet( ( rand() % 100 ) * 0.01f - 0.5f, ( rand() % 100 ) * 0.01f - 0.5f );
	obb.vVel.VecZero();
	obb.fAngle = 3.14 * ( rand() % 100 ) * 0.005f;
	obb.vSiz.VecSet( 0.25f, 0.15f );
	obb.fW = 0.0f;
	obb.funcReload();
	// 
	player.vPos.VecZero();	// 
	player.vVel.VecZero();	// 
	player.fAngle = 0.0f;	//  
	player.vSiz.VecSet( 0.25f, 0.15f );	// 
	player.fW = 0.0f;	//  
	player.funcReload();	//  
}

void SetDCPixelFormat( HDC hDc )
{
	PIXELFORMATDESCRIPTOR		pfd;
	int							nPixelFormat;

	memset( &pfd, 0, sizeof( PIXELFORMATDESCRIPTOR ) );
	pfd.dwFlags = PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER;
	nPixelFormat = ChoosePixelFormat( hDc, &pfd );
	SetPixelFormat( hDc, nPixelFormat, &pfd );
}

LRESULT CALLBACK WndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	switch( uMsg )
	{
	case WM_KEYDOWN:
		switch( wParam )
		{
		case VK_ESCAPE:
			PostQuitMessage( 0 );

			break;
		case VK_SPACE:
			funcGenerate();

			break;
		}

		bKeys[ wParam ] = true;

		break;
	case WM_KEYUP:
		bKeys[ wParam ] = false;

		break;
	case WM_CLOSE:
		PostQuitMessage( 0 );

		break;
	case WM_CREATE:
		hDc = GetDC( hWnd );
		SetDCPixelFormat( hDc );
		hRc = wglCreateContext( hDc );

		wglMakeCurrent( hDc, hRc );

		srand( GetTickCount() );

		funcGenerate();

		break;
	default:
		return DefWindowProc( hWnd, uMsg, wParam, lParam );
	}
}

void funcOBBMain( void )
{
	clVec2	vPush;
	clVec2	vPoint;
	float	fDepth;

	if( bKeys[ VK_UP ] )
	{
		player.vPos += clVec2( 0.0f, fSpeed ) * fDelTime;
	}
	if( bKeys[ VK_DOWN ] )
	{
		player.vPos -= clVec2( 0.0f, fSpeed ) * fDelTime;
	}
	if( bKeys[ VK_LEFT ] )
	{
		player.vPos -= clVec2( fSpeed, 0.0f ) * fDelTime;
	}
	if( bKeys[ VK_RIGHT ] )
	{
		player.vPos += clVec2( fSpeed, 0.0f ) * fDelTime;
	}
	if( bKeys[ 'Q' ] )
	{
		player.fAngle += 0.005f * fDelTime;
	}
	if( bKeys[ 'W' ] )
	{
		player.fAngle -= 0.005f * fDelTime;
	}

	glColor3f( 1.0f, 0.0f, 0.0f );

	if( cl.funcIntersectSpherexOBB( sph, player, vPush, fDepth, vPoint ) )
	{
		player.vPos -= vPush * fDepth;

		glPointSize( 10.0f );

		glBegin( GL_POINTS );
			glVertex2fv( ( float * )&( vPoint ) );
		glEnd();
	}

	if( cl.funcIntersectOBBxLine( player, line, vPush, fDepth, vPoint ) )
	{
		player.vPos -= vPush * fDepth;

		glPointSize( 10.0f );

		glBegin( GL_POINTS );
			glVertex2fv( ( float * )&( vPoint - vPush * fDepth ) );
		glEnd();
	}

	if( cl.funcIntersectOBBxOBB( player, obb, vPush, fDepth, vPoint ) )
	{
		player.vPos -= vPush * fDepth;

		glPointSize( 10.0f );

		glBegin( GL_POINTS );
			glVertex2fv( ( float * )&( vPoint - vPush * fDepth ) );
		glEnd();
	}

	player.funcReload();
	line.funcReload();
	obb.funcReload();

	glColor3f( 1.0f, 1.0f, 1.0f );
	sph.funcRender( 32 );
	line.funcRender();
	obb.funcRender();

	glColor3f( 0.0f, 1.0f, 0.0f );
	player.funcRender();
}

WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd )
{
	WNDCLASSEX		wclass;
	MSG				msg;
	HWND			hWnd;

	memset( &wclass, 0,sizeof( WNDCLASSEX ) );
	memset( &msg, 0, sizeof( MSG ) );

	wclass.cbSize = sizeof( WNDCLASSEX );
	wclass.lpfnWndProc = WndProc;
	wclass.lpszClassName = "CCollide";

	RegisterClassEx( &wclass );

	hWnd = CreateWindowEx( 0, "CCollide", "Coll", WS_POPUP, 0, 0, 1024, 768, 0, 0, 0, 0 );

	ShowWindow( hWnd, SW_SHOW );

	ShowCursor( false );

	fOldTime = GetTickCount();

	while( msg.message != WM_QUIT )
	{
		if( PeekMessage( &msg, 0, 0, 0, PM_REMOVE ) )
		{
			TranslateMessage( &msg );
			DispatchMessage( &msg );
		}
		else
		{
			fCurTime = GetTickCount();
			fDelTime = fCurTime - fOldTime;
			fOldTime = fCurTime;

			glClear( GL_COLOR_BUFFER_BIT );

			funcOBBMain();

			SwapBuffers( hDc );
		}
	}

	return 0;
}